#include <bits/stdc++.h>

#define X first
#define Y second
#define PB push_back
#define x first
#define y second
#define pb push_back
#define all(a) begin(a),end(a)
#define sz(a) (int)(a).size()
#define rep(i,a,b) for (int i=a;i<(b);++i)

using namespace std;

typedef long long ll;
using ld=double;
using pii=pair<int,int>;
using vl=vector<ll>;
typedef vector<int> vi;

const int N=610,MOD=1e9+7;
const char en='\n';
const ll LLINF=1ll<<60;

template<class T> int sgn(T x) {return (x>0)-(x<0);}
template<class T>
struct Point {
	typedef Point P;
	T x,y;
	explicit Point(T x=0,T y=0) : x(x),y(y) {}
	bool operator<(P p) const {return tie(x,y)<tie(p.x,p.y);}
	bool operator==(P p) const {return tie(x,y)==tie(p.x,p.y);}
	P operator+(P p) const {return P(x+p.x,y+p.y);}
	P operator-(P p) const {return P(x-p.x,y-p.y);}
	P operator*(T d) const {return P(x*d,y*d);}
	P operator/(T d) const {return P(x/d,y/d);}
	T dot(P p) const {return x*p.x+y*p.y;}
	T cross(P p) const {return x*p.y-y*p.x;}
	T cross(P a,P b) const {return (a-*this).cross(b-*this);}
	T dist2() const {return x*x+y*y;}
	double dist() const {return sqrt(dist2());}
	double angle() const {return atan2(y,x);}
	P unit() const {return *this/dist();}
	P perp() const {return P(-y,x);}
	friend ostream& operator<<(ostream& os,P p) {
		return os<<"("<<p.x<<","<<p.y<<")";
	}
};

using T=ld;
using P=Point<ld>;

T polygonArea(vector<P>&v)
{
	T a=v.back().cross(v[0]);
	rep(i,0,sz(v)-1) a+=v[i].cross(v[i+1]);
	return a/2;
}

vector<P> convexHull(vector<P> pts)
{
	if (sz(pts)<=1) return pts;
	sort(all(pts));
	vector<P> h(sz(pts)+1);
	int s=0,t=0;
	for (int it=2;it--;s=--t,reverse(all(pts))) for (P p: pts)
	{
		while (t>=s+2 && h[t-2].cross(h[t-1],p)<=0) --t;
		h[t++]=p;
	}
	return {h.begin(),h.begin()+t-(t==2 && h[0]==h[1])};
}

const int dx[]={0,1,0,-1};
const int dy[]={1,0,-1,0};
int h[N][N],n,n1;

vector<vi> bfs(int px,int py)
{
	vector<vi> dis(n1,vi(n1,MOD));
	vector<vi> bio(n1,vi(n1));
	priority_queue<pair<int,pii>> pq;
	pq.push({0,{px,py}});
	dis[px][py]=0;
	while (pq.size())
	{
		int di=pq.top().x;
		int i=pq.top().y.x,j=pq.top().y.y;
		pq.pop();
		if (bio[i][j]) continue;
		bio[i][j]=1;
		for (int k=0;k<4;++k)
		{
			int i1=i+dx[k],j1=j+dy[k];
			if (i1<0 || j1<0 || i1>=n1 || j1>=n1 || bio[i1][j1]) continue;
			int ndi=abs(h[i1][j1]-h[i][j])+1-di;
			if (dis[i1][j1]<ndi) continue;
			dis[i1][j1]=ndi;
			pq.push({-ndi,{i1,j1}});
		}
	}
	return dis;
}

const int K=40,SZ=K*2+1;
const ld MAXD=1e20;
using mat=array<array<ll,SZ>,SZ>;
mat mv;

ld getCount(mat x)
{
	//cout<<"ru"<<endl;
	//for (int i=0;i<2*n;++i,cout<<en) for (int j=0;j<2*n;++j) cout<<x[i][j]<<' ';
	vector<vl> dis(SZ+1,vl(SZ,LLINF));
	dis[0][0]=0;
	for (int d=0;d<2*n-1;++d) for (int i=0;i<2*n-1;++i) for (int j=0;j<2*n-1;++j) dis[d+1][j]=min(dis[d+1][j],dis[d][i]+x[i][j]);
	ld mi=LLINF;
	for (int i=0;i<2*n-1;++i)
	{
		ld ma=-LLINF;
		for (int k=1;k<=2*n-1;++k) ma=max(ma,(dis[2*n-1][i]-dis[2*n-1-k][i])/ld(k));
		mi=min(mi,ma);
	}
	//cout<<mi<<en;
	return MAXD/mi;
}

mat cma[SZ][SZ];

const bool DEB=0;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	for (int i=0;i<SZ;++i) for (int j=0;j<SZ;++j)
	{
		mv[i][j]=LLINF;
	}
	if (DEB) n=20;
	else cin>>n;
	int kol=n+1;
	n1=n*kol;
	for (int i=0;i<n;++i) for (int j=0;j<n;++j)
	{
		if (DEB) h[i][j]=rand()%1536;
		else cin>>h[i][j];
		for (int i1=0;i1<kol;++i1) for (int j1=0;j1<kol;++j1) h[i+i1*n][j+j1*n]=h[i][j];
	}
	//90-180 cw from north
	for (int i=0;i<SZ;++i) for (int j=0;j<SZ;++j)
	{
		cma[i][j]=mv;
	}
	for (int i=-(n-1);i<n;++i)
	{
		auto re=bfs(max(i,0),max(-i,0));
		for (int cy=0;cy<=n;++cy) for (int cx=0;cx<=n;++cx) if (gcd(cx,cy)==1)
		{
			for (int kr=-(n-1);kr<n;++kr)
			{
				int novx=cx*n+max(kr,0);
				int novy=cy*n+max(-kr,0);
				//cout<<cx<<' '<<cy<<' '<<novx<<' '<<novy<<' '<<re[novx][novy]<<endl;
				cma[cx+n][cy+n][i+(n-1)][kr+(n-1)]=re[novx][novy];
			}
		}
	}
	//cout<<"p1"<<endl;
	//0-90 cw from north
	for (int i=-(n-1);i<n;++i)
	{
		auto re=bfs(max(i,0)+(kol-1)*n,max(-i,0));
		for (int cy=0;cy<=n;++cy) for (int cx=-n;cx<=0;++cx) if (gcd(abs(cx),cy)==1)
		{
			for (int kr=-(n-1);kr<n;++kr)
			{
				int novx=(kol-1)*n+cx*n+max(kr,0);
				int novy=cy*n+max(-kr,0);
				cma[cx+n][cy+n][i+(n-1)][kr+(n-1)]=re[novx][novy];
			}
		}
	}
	//cout<<"p2"<<endl;
	vector<P> hullcand;
	for (int cy=0;cy<=n;++cy) for (int cx=0;cx<=n;++cx) if (gcd(cx,cy)==1)
	{
		ld cou=getCount(cma[cx+n][cy+n]);
		hullcand.pb(P(cx*n,cy*n)*cou);
		hullcand.pb(P(0,0)-P(cx*n,cy*n)*cou);
	}
	for (int cy=0;cy<=n;++cy) for (int cx=-n;cx<=0;++cx) if (gcd(abs(cx),cy)==1)
	{
		ld cou=getCount(cma[cx+n][cy+n]);
		hullcand.pb(P(cx*n,cy*n)*cou);
		hullcand.pb(P(0,0)-P(cx*n,cy*n)*cou);
	}
	//cout<<"cands"<<endl;
	//for (auto x: hullcand) cout<<x<<endl;
	vector<P> hull=convexHull(hullcand);
	cout<<setprecision(10)<<polygonArea(hull)<<endl;
}
